import java.lang.reflect.Array;
import java.util.*;

public class Arraz {

    public int sumValuesOfArrays(int[] intArray) {
        int result = 0;
        for (int i: intArray) {
            result+=i;
        }
        return result;
    }

    public Double sumDoubleOfArrays(Double[] doubleArray) {
        double result = 0;
        for (Double d: doubleArray) {
            result+=d;
        }
        return result;
    }

    public int average(int[] arr) {
        return sumValuesOfArrays(arr)/arr.length;
    }

    public Double averageDbl(Double[] arr) {
        return sumDoubleOfArrays(arr)/arr.length;
    }

    public boolean containsValue(int[] spiffyHandyIntArray, int i) {
        for (int value: spiffyHandyIntArray) {
            if(i==value){return true;}
        }
        return false;
    }

    public int[] reverse(int[] arr) {
        for(int i = 0; i<arr.length/2; i++){
           int temp = arr[i];
           arr[i]=arr[arr.length-i-1];
           arr[arr.length-i-1]=temp;
        }
        return arr;
    }

    public OddEven getOddEvensOfArray(int[] arr) {
        int even = 0;
        int odd = 0;
        for (int i: arr) {
            if(i%2==0) even++;
            else odd++;
        }
        return new OddEven(odd, even);
    }

    public int findIndexOf(int[] arr, int value) {
        for (int i=0; i<arr.length; i++) {
            if (arr[i] == value) {
                return i;
            }
            }
        return -1;
    }

    public Integer[] copyArrayByIterator(Integer[] arr) {
        Integer[] array = new Integer[arr.length];
        Iterator<Integer> iterator = Arrays.asList(arr).iterator();
        int counter = 0;
        while(iterator.hasNext()){
            array[counter]=iterator.next();
            counter++;
        }
        return  array;
        }


    public int[] copyArrayByLoop(int[] arr) {
        int [] result = new int[arr.length];
        for(int i=0; i<arr.length; i++){
            result[i]=arr[i];
        }
        return result;
    }

    public int[] removeElement(int[] arr, int val) {
        int[] result = new int[arr.length-1];
        int count =0;
        for(int i=0; i<arr.length; i++){
            if(arr[i]!=val){
            result[count]=arr[i];
            count++;}
        }
        return result;
    }

    public int[] insertIntoArrayAt(int[] arr, int val, int index) {
       if (index> arr.length+1) throw new ArrayIndexOutOfBoundsException();
        int[] result = new int[arr.length+1];
        int counter = 0;
        for (int i = 0; i <result.length; i++) {
            if (i != index){
                result[i] = arr[counter];
                counter++;
            } else result[i] = val;
        }
        return result;
    }

    public MinMax findMinMax(int[] arr) {
        Arrays.sort(arr);
        return new MinMax(arr[0], arr[arr.length-1]);
    }

    public Integer[] removeDupes(Integer[] arr) {
        Set<Integer> set = new HashSet<Integer>();
        for (Integer i : arr) {
            set.add(i);
        }
        Integer[] result = new Integer[set.size()];
        int counter = 0;
        for (Integer i: set) {
            result[counter]=i;
            counter++;
        }
        return result;
    }

    public int find2ndLargest(int[] arr) {
        Arrays.sort(arr);
        return arr[arr.length-2];
    }

    public ArrayList<Integer> makeArrayList(int[] arr) {
        ArrayList<Integer> result = new ArrayList<Integer>();
        for (int i : arr) {
            result.add((Integer)i);
        }
        return result;
    }

    public int[] makeArray(ArrayList<Integer> list) {
        int[] result = new int[list.size()];
        for (int i = 0; i < list.size(); i++) {
            result[i]=(int)list.get(i);
        }
        return result;
    }

    public boolean check2Arrays(int[] arr1, int[] arr2) {
        if(arr1.length!=arr2.length) return false;
        for (int i = 0; i < arr1.length; i++) {
            if(arr1[i] != arr2[i]) return false;
        }
        return true;
    }

    public int averageWithoutMinMax(int[] arr) {
        Arrays.sort(arr);
        int result = 0;
        for (int i = 1; i < arr.length-1; i++) {
            result += arr[i];
        }
        return result/(arr.length-2);
    }

    public boolean has65and77(int[] testArr) {
        boolean contains65 = false;
        boolean contains77 = false;
        for (int i: testArr) {
            if (i ==65) contains65=true;
            if (i==77) contains77=true;
        }
        return (contains65&&contains77);
    }

    public boolean toalOf10sIs30(int[] arr) {
        int tenCount = 0;
        for (int i : arr) {
            if (i==10) tenCount++;
        }
        return (tenCount==3);
    }

    public int[] makeCopyReverse(int[] arr) {
      return reverse(copyArrayByLoop(arr));
    }

    public int[] removeLastAndCopy(int[] arr) {
        return copyArrayByLoop(removeElement(arr,arr[arr.length-1]));
    }

    public int[] removeFirstAndCopy(int[] arr) {
        return copyArrayByLoop(removeElement(arr,arr[0]));
    }

    public int[] insertFirstAndCopy(int[] arr, int i) {
        return copyArrayByLoop(insertIntoArrayAt(arr, i, 0));
    }

    public int[] insertEndAndCopy(int[] arr, int i) {
        return copyArrayByLoop(insertIntoArrayAt(arr, i, arr.length));
    }

    public int[] sortArrayEvenOdd(int[] arr) {
        ArrayList<Integer> evens = new ArrayList<Integer>();
        ArrayList<Integer> odds = new ArrayList<Integer>();
        int[] result = new int[arr.length];
        int count = 0;
        for (int i: arr) {
            if(i%2==0) evens.add(i);
            else odds.add(i);
        }
        for (Integer j: evens) {
            result[count]=j;
            count++;
        }
        for (Integer k:odds) {
            result[count]=k;
            count++;
        }
        return result;
    }
}
